Hang on, I'm confused though - it says:

For now, the redsn0w beta release supports only the iPhone3G and iPod Touch 2G at today’s 4.0. It’s still a beta, so you’ll need to let Cydia reorganize, reload, and update after using redsn0w.

Isn't that what you have?
_________________________
If it's brokenless, don't suffix it...